//arays
var par = new Array;

var ie = ["<!--[if IE]>"+"\n"+"Your style for all Internet Explorer here"+"\n"+"<![endif]-->"];

var ie5 = ["<!--[if IE 5]>"+"\n"+"Your style for Internet Explorer 5 here"+"\n"+"<![endif]-->"];

var ie55 = ["<!--[if IE 5.5]>"+"\n"+"Your style for Internet Explorer 5.5 here"+"\n"+"<![endif]-->"];

var ie6 = ["<!--[if IE 6]>"+"\n"+"Your style for Internet Explorer 6 here"+"\n"+"<![endif]-->"];

var ie7 = ["<!--[if IE 7]>"+"\n"+"Your style for Internet Explorer 7 here"+"\n"+"<![endif]-->"];

var gteie5 = ["<!--[if gte IE 5]>"+"\n"+"Your style for Internet Explorer 5 and up here"+"\n"+"<![endif]-->"];

var ltie6 = ["<!--[if lt IE 6]>"+"\n"+"Your style for Internet Explorer lower than 6 here"+"\n"+"<![endif]-->"];

var lteie7 = ["<!--[if lte IE 7]>"+"\n"+"Your style for Internet Explorer lower or equal to 7 here"+"\n"+"<![endif]-->"];

var gtie55 = ["<!--[if gt IE 5.5]>"+"\n"+"Your style for Internet Explorer greater than 5.5 here"+"\n"+"<![endif]-->"];


//localization
function getLocalizedString(key)
{
    try {
        var ret = localizedStrings[key];
        if (ret === undefined)
            ret = key;
        return ret;
    } catch (ex) {}
    return key;
}

//setup
function setup()
{
	var doneButton = document.getElementById('done');
	var copyButton = document.getElementById('copy');
	var selectMenu = document.getElementById('popup');
	createGenericButton(doneButton, getLocalizedString('Done'), hidePrefs);
	createGenericButton(copyButton, getLocalizedString('Copy it for me'), copyToPastboard);
	document.getElementById("menuText").innerText = getLocalizedString('Choose a version of IExplorer');
	document.getElementById("sliderText").innerText = getLocalizedString('Size : ');
	selectMenu.options.length = 0;
	selectMenu.options[0] = new Option(getLocalizedString('if IE'), "ie", false, false);
	selectMenu.options[1] = new Option(getLocalizedString('if IE 5'), "ie5", true, true);
	selectMenu.options[2] = new Option(getLocalizedString('if IE 5.5'), "ie55", false, false);
	selectMenu.options[3] = new Option(getLocalizedString('if IE 6'), "ie6", false, false);
	selectMenu.options[4] = new Option(getLocalizedString('if IE 7'), "ie7", false, false);
	selectMenu.options[5] = new Option(getLocalizedString('if IE 5 and up'), "gteie5", false, false);
	selectMenu.options[5] = new Option(getLocalizedString('if lower than IE 6'), "ltie6", false, false);
	selectMenu.options[5] = new Option(getLocalizedString('if lower or equal to IE 7'), "lteie7", false, false);
	selectMenu.options[5] = new Option(getLocalizedString('if greater than IE 5.5'), "gtie55", false, false);
}

// select menu
function menuChanged(elem)
{
	var chosenItem = elem.options[elem.selectedIndex].text;
	document.getElementById("menuText").innerText = chosenItem;
	if (elem.options[elem.selectedIndex].value == "page") {
		window.resizeTo(370, 250);
		document.getElementById('backgroundImage').style.display='none';
		document.getElementById('pageImage').style.display='block';
		document.getElementById('footer').style.display='block';
		document.getElementById('parentDiv').style.display = 'block';
		sliderChanged();
	} else {
		window.resizeTo(370, 100);
		document.getElementById('backgroundImage').style.display='block';
		document.getElementById('pageImage').style.display='none';
		document.getElementById('footer').style.display='none';
		document.getElementById('parentDiv').style.display = 'none';
	}
}

//slider control
function sliderChanged()
{
	var sliderValue = document.getElementById('sliderControl').value;
	var totalWords = sliderValue * 10;
	var temptxt = "";
	var lorem = "";
	for (i=1; i<13; i++) {
		temptxt = temptxt + "<p>";
		temptxt = temptxt + par[i];
		temptxt = temptxt + "</p>";
	}
	var words = temptxt.split(" ");
	for (j=0; j<totalWords; j++) {
		lorem = lorem + words[j] +" ";
	}
	lorem = lorem.substring(0, lorem.lastIndexOf(".")+1);
	var realWords = lorem.split(" ");
	var realTotalWords = realWords.length;
	var stats = realTotalWords+" "+getLocalizedString('words')+" / "+lorem.length+" "+getLocalizedString('signs');
	document.getElementById('countText').innerText = stats;
	document.getElementById('scrollText').innerHTML = lorem;
	calculateAndShowThumb(document.getElementById('scrollText'));
}

// click copy to pastboard
function copyToPastboard()
{
	var type = document.getElementById('popup').value;
	var lorem = "";
	if (type == "paragraph") {
		var arrayLength = par.length;
		var pick = Math.floor(arrayLength * Math.random()) + 1;
		lorem = par[pick];
	} else if (type == "sentence") {
		var arrayLength = par.length;
		var pick = Math.floor(arrayLength * Math.random()) + 1;
		var paragraph = par[pick];
		var sen = paragraph.split(".");
		arrayLength = sen.length;
		pick = Math.floor(arrayLength * Math.random());
		var temp = trim(sen[pick]);
		if (temp == "") {
			var temp = trim(sen[pick-1]);
		}
		lorem = temp + ".";
	} else if (type == "word") {
		var arrayLength = words.length;
		var pick = Math.floor(arrayLength * Math.random());
		lorem = words[pick];
	} else if (type == "title") {
		var arrayLength = titles.length;
		var pick = Math.floor(arrayLength * Math.random());
		lorem = titles[pick];
// ================================= //	
	} else if (type == "ie") {
		var arrayLength = ie.length;
		var pick = Math.floor(arrayLength * Math.random());
		lorem = ie[pick];
	} else if (type == "ie5") {
		var arrayLength = ie5.length;
		var pick = Math.floor(arrayLength * Math.random());
		lorem = ie5[pick];
	} else if (type == "ie55") {
		var arrayLength = ie55.length;
		var pick = Math.floor(arrayLength * Math.random());
		lorem = ie55[pick];
	} else if (type == "ie6") {
		var arrayLength = ie6.length;
		var pick = Math.floor(arrayLength * Math.random());
		lorem = ie6[pick];
	} else if (type == "ie7") {
		var arrayLength = ie7.length;
		var pick = Math.floor(arrayLength * Math.random());
		lorem = ie7[pick];
	} else if (type == "gteie5") {
		var arrayLength = gteie5.length;
		var pick = Math.floor(arrayLength * Math.random());
		lorem = gteie5[pick];
	} else if (type == "ltie6") {
		var arrayLength = ltie6.length;
		var pick = Math.floor(arrayLength * Math.random());
		lorem = ltie6[pick];
	} else if (type == "lteie7") {
		var arrayLength = lteie7.length;
		var pick = Math.floor(arrayLength * Math.random());
		lorem = lteie7[pick];
	} else if (type == "gtie55") {
		var arrayLength = gtie55.length;
		var pick = Math.floor(arrayLength * Math.random());
		lorem = gtie55[pick];
// ================================= //		
	} else if (type == "list") {
		var arrayLength = titles.length;
		for (i=1; i<6; i++) {
			var pick = Math.floor(arrayLength * Math.random());
			lorem = lorem + titles[pick] + "\n\n";
		}
	} else {
		lorem = document.getElementById('scrollText').innerText;
	}
	var obj = widget.system("osascript -e 'set the clipboard to \""+lorem+"\"'", null);
}

//show web page
function getUrl(site)
{
 if (widget)
 {
 	widget.openURL(site);
 }
}

//trim function
function trim(s) {
  while (s.substring(0,1) == ' ') {
    s = s.substring(1,s.length);
  }
  while (s.substring(s.length-1,s.length) == ' ') {
    s = s.substring(0,s.length-1);
  }
  return s;
}


/*********************************/
// HIDING AND SHOWING PREFERENCES
/*********************************/

// showPrefs() is called when the preferences flipper is clicked upon.  It freezes the front of the widget,
// hides the front div, unhides the back div, and then flips the widget over.

function showPrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToBack");		// freezes the widget so that you can change it without the user noticing
	
	front.style.display="none";		// hide the front
	back.style.display="block";		// show the back
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget over	

	document.getElementById('fliprollie').style.display = 'none';  // clean up the front side - hide the circle behind the info button

}


// hidePrefs() is called by the done button on the back side of the widget.  It performs the opposite transition
// as showPrefs() does.

function hidePrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToFront");		// freezes the widget and prepares it for the flip back to the front
	
	back.style.display="none";			// hide the back
	front.style.display="block";		// show the front
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget back to the front
}


// PREFERENCE BUTTON ANIMATION (- the pref flipper fade in/out)

var flipShown = false;		// a flag used to signify if the flipper is currently shown or not.


// A structure that holds information that is needed for the animation to run.
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};


// mousemove() is the event handle assigned to the onmousemove property on the front div of the widget. 
// It is triggered whenever a mouse is moved within the bounds of your widget.  It prepares the
// preference flipper fade and then calls animate() to performs the animation.

function mousemove (event)
{
	if (!flipShown)			// if the preferences flipper is not already showing...
	{
		if (animation.timer != null)			// reset the animation timer value, in case a value was left behind
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; 		// set it back one frame
		
		animation.duration = 500;												// animation time, in ms
		animation.starttime = starttime;										// specify the start time
		animation.firstElement = document.getElementById ('flip');		// specify the element to fade
		animation.timer = setInterval ("animate();", 13);						// set the animation function
		animation.from = animation.now;											// beginning opacity (not ness. 0)
		animation.to = 1.0;														// final opacity
		animate();																// begin animation
		flipShown = true;														// mark the flipper as animated
	}
}

// mouseexit() is the opposite of mousemove() in that it preps the preferences flipper
// to disappear.  It adds the appropriate values to the animation data structure and sets the animation in motion.

function mouseexit (event)
{
	if (flipShown)
	{
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}


// animate() performs the fade animation for the preferences flipper. It uses the opacity CSS property to simulate a fade.

function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.firstElement.style.opacity = animation.now;
}


// these functions are utilities used by animate()

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

// these functions are called when the info button itself receives onmouseover and onmouseout events

function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}
